import "Turbine.UI"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement

-- Special thanks to 
-- Koios for their German & French translations
-- Garan for the intro to LUA

-- VERSION HISTORY
-- ===============
-- V1.2 - German & French versions + Helegrod instances added + /sktr now a toggle
-- V1.1 - German version
-- V1.0 - Initial Release


-- no laughing at the back I don't do LUA

-- find client language
 local locale = "en";
 if Turbine.Shell.IsCommand("hilfe") then
  locale = "de";
 elseif Turbine.Shell.IsCommand("aide") then
  locale = "fr";
 end

 

-- List of skirmishes probably should put this in it's own file
-- Ahh the dreaded do arrays start at 0 or 1 seems to start at 0 if you use [] and 1 otherwise

skirmishes={};
skirmishes["en"]={
"Ford of Bruinen",
"Siege of Gondamon",
"Trouble in Tuckborough",
"Stand at Amon S\195\187l",
"Strike Against Dannenglor",
"Protectors of Thangulhad",
"Breaching the Necromancer's Gate",
"Assault on the Ringwraiths' Lair",
"Battle in the Tower",
"Defense of the Prancing Pony",
"Thievery and Mischief",
"Rescue in N\195\187rz Gh\195\162shu",
"Battle of the Deep-Way",
"Battle of the Way of Smiths",
"Battle of the Twenty-First Hall",
"The Icy Crevasse",
"Attack at Dawn",
"Helegrod: Dragon Wing",
"Helegrod: Drake Wing",
"Helegrod: Giant Wing",
"Helegrod: Spider Wing"
};


skirmishes["de"]= {
"Die Bruinenfurt",
"Die Belagerung von Gondamon",
"\195\132rger in Buckelstadt",
"Das Gefecht am Amon Sul",
"Schlag gegen Dannenglor",
"Besch\195\188tzer von Thangulhad",
"Der Durchbruch am Tor des Geisterbeshw\195\182rers",
"Der Angriff auf das Versteck der Ringgeister",
"Der Kampf im Turm",
"Die Verteidigung des 'T\195\162nzelnden Ponys'",
"Dieberei und Unheil",
"Rettung in N\195\187rz Gh\195\162shu",
"Der Kampf um den Tiefweg",
"Der Kampf um den Weg der Schmiede",
"Der Kampf um die Einundzwanzigste Halle",
"Die Eisige Kluft",
"Angriff bei Morgengrauen",
"Helegrod: Drachen-Trakt",
"Helegrod: Drachenbrut-Trakt",
"Helegrod: Riesen-Trakt",
"Helegrod: Spinnen-Trakt"
};
skirmishes["fr"]={
"Gu\195\169 de Bruinen",
"Si\195\168ge de Gondamon",
"Trouble \195\160 Bourg de Touque",
"La d\195\169fense d'Amon S\195\187l",
"Attaque contre Dannenglor",
"Protecteurs de Thangulhad",
"Forcer la porte du N\195\169cromancien",
"A l'assaut de l'antre des Spectres de l'Anneau",
"La bataille dans la tour",
"D\195\169fense du Poney Fringant",
"M\195\169faits et brigandages",
"Sauvetage \195\160 N\195\187rz Gh\195\162shu",
"Bataille de la Voie des Tr\195\169fonds",
"Bataille de la Voie des Forgerons",
"Bataille de la vingt et uni\195\168me salle",
"La Crevasse glac\195\169e",
"Attaque \195\160 l'aube",
"Helegrod: aile de dragon",
"Helegrod: aile de drake",
"Helegrod: aile de g\195\169ant",
"Helegrod: aile d'araign\195\169e"
};

otherText ={};
otherText["en"]= {
"Skirmish Raid Tracker",
"Save",
"Reset All"
};
otherText["de"] = {
"Scharm\195\188tzel\195\188bersicht",
"Speichern",
"Neustart"
};
otherText["fr"] = {
"Escarmouches",
"Enregistrer",
"R\195\169initialiser"
};

local skTotal=table.maxn(skirmishes["en"]);  -- wonder what else I should make local?

-- Lets create the window

skirmWindow=Turbine.UI.Lotro.Window(); 
skirmWindow:SetSize(380,600); 
skirmWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-190,Turbine.UI.Display:GetHeight()/2-300); 
skirmWindow:SetText(otherText[locale][1]); 

-- Placeholder for checkboxes
skirmWindow.skcb = { };

-- Put checkboxes in window
for i = 1, skTotal do
	skirmWindow.skcb[i]=Turbine.UI.Lotro.CheckBox();
	skirmWindow.skcb[i]:SetParent(skirmWindow);
	skirmWindow.skcb[i]:SetSize(360,20);
	skirmWindow.skcb[i]:SetPosition(10,20 +(i*25));
	skirmWindow.skcb[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	skirmWindow.skcb[i]:SetText(" " .. skirmishes[locale][i]);
end
-- Add the buttons
skirmWindow.SaveBtn =Turbine.UI.Lotro.Button();
skirmWindow.SaveBtn:SetText(otherText[locale][2]);
skirmWindow.SaveBtn:SetPosition( 40, 570 );
skirmWindow.SaveBtn:SetSize( 90, 20 );
skirmWindow.SaveBtn:SetParent(skirmWindow);

skirmWindow.ResetBtn =Turbine.UI.Lotro.Button();
skirmWindow.ResetBtn:SetText(otherText[locale][3]);
skirmWindow.ResetBtn:SetPosition( 210, 570 );
skirmWindow.ResetBtn:SetSize( 90, 20 );
skirmWindow.ResetBtn:SetParent(skirmWindow);

-- I don't know LUA but this is screaming out to me as bad should be in a LoadSettings

settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "SkirmishTracker" );

	if ( type( settings ) ~= "table" ) then
		settings = { };
		settings.positionX=Turbine.UI.Display:GetWidth()/2-190;
		settings.positionY=Turbine.UI.Display:GetHeight()/2-300;
		settings.skirmishDone = {};
	end
	
	skirmWindow:SetPosition(settings.positionX, settings.positionY);
	
	for i=1,skTotal do
		skirmWindow.skcb[i]:SetChecked(settings.skirmishDone[i]);
	end

-- 

skirmWindow:SetVisible(true);

-- Bit so you can show window from chat

SkirmishTrackerCommand = Turbine.ShellCommand();

function SkirmishTrackerCommand:Execute( command, arguments )
	skirmWindow:SetVisible( not skirmWindow:IsVisible());
end

Turbine.Shell.AddCommand("sktr", SkirmishTrackerCommand);

-- Button Events
skirmWindow.ResetBtn.Click = function( sender, args )
	for i=1,skTotal do
	skirmWindow.skcb[i]:SetChecked(false);
	end
end

skirmWindow.SaveBtn.Click = function( sender, args )
	for i=1,skTotal do
	settings.skirmishDone[i]=skirmWindow.skcb[i]:IsChecked();
	end
	Turbine.PluginData.Save( Turbine.DataScope.Character, "SkirmishTracker", settings );
end

-- Hopefully this tracks windows position - makes save button redundant I think too
skirmWindow.MouseLeave = function( sender, args )

	X, Y = skirmWindow:GetPosition();
	settings.positionX=X;
	settings.positionY=Y;
	skirmWindow.SaveBtn.Click(); -- bad wal

end
